{# Template for sshd_config file #}
{{ ansible_managed | comment }}

# This is the sshd server system-wide configuration file.
# See sshd_config(5) for more information.

# Connection
# ==========

{% for port in ssh_config_port %}
Port {{ port | int | string }}
{% endfor %}
{% if ssh_config_addressfamily in ['any', 'inet', 'inet6'] %}
AddressFamily {{ ssh_config_addressfamily }}
{% endif %}
{% for address in ssh_config_listenaddress %}
ListenAddress {{ address }}
{% endfor %}
{% if ssh_config_rdomain != 'none' %}
RDomain {{ ssh_config_rdomain }}
{% endif %}

# Global Authentication
# =====================

AuthenticationMethods {{ ssh_config_authenticationmethods }}
KbdInteractiveAuthentication {{ 'yes' if ssh_config_kbdinteractiveauthentication else 'no' }}
PermitRootLogin {{ 'yes' if ssh_config_permitrootlogin else 'no' }}
UsePAM {{ 'yes' if ssh_config_usepam else 'no' }}

# Password Authentication
# =======================

PasswordAuthentication {{ 'yes' if ssh_config_passwordauthentication else 'no' }}
PermitEmptyPasswords {{ 'yes' if ssh_config_permitemptypasswords else 'no' }}

# Public Key Authentication
# =========================

PubkeyAuthentication {{ 'yes' if ssh_config_pubkeyauthentication else 'no' }}
AuthorizedKeysFile {{ ssh_config_authorizedkeysfile }}
{% if ssh_config_trustedusercakeys != 'none' %}
TrustedUserCAKeys {{ ssh_config_trustedusercakeys }}
{% endif %}
{% if ssh_config_revokedkeys != 'none' %}
RevokedKeys {{ ssh_config_revokedkeys }}
{% endif %}
{% if ssh_config_authorizedkeyscommand != 'none' %}
AuthorizedKeysCommand {{ ssh_config_authorizedkeyscommand }}
{% endif %}
{% if ssh_config_authorizedkeyscommanduser != 'none' %}
AuthorizedKeysCommandUser {{ ssh_config_authorizedkeyscommanduser }}
{% endif %}
{% if ssh_config_authorizedprincipalscommand != 'none' %}
AuthorizedPrincipalsCommand {{ ssh_config_authorizedprincipalscommand }}
{% endif %}
{% if ssh_config_authorizedprincipalscommanduser != 'none' %}
AuthorizedPrincipalsCommandUser {{ ssh_config_authorizedprincipalscommanduser }}
{% endif %}
{% if ssh_config_authorizedprincipalsfile != 'none' %}
AuthorizedPrincipalsFile {{ ssh_config_authorizedprincipalsfile }}
{% endif %}

# Kerberos Authentication
# =======================

KerberosAuthentication {{ 'yes' if ssh_config_kerberosauthentication else 'no' }}
{% if ssh_config_kerberosauthentication %}
KerberosOrLocalPasswd {{ 'yes' if ssh_config_kerberosorlocalpasswd else 'no' }}
KerberosGetAFSToken {{ 'yes' if ssh_config_kerberosgetafstoken else 'no' }}
KerberosTicketCleanup {{ 'yes' if ssh_config_kerberosticketcleanup else 'no' }}
{% endif %}

# GSSAPI Authentication
# =====================

GSSAPIAuthentication {{ 'yes' if ssh_config_gssapiauthentication else 'no' }}
{% if ssh_config_gssapiauthentication %}
GSSAPICleanupCredentials {{ 'yes' if ssh_config_gssapicleanupcredentials else 'no' }}
GSSAPIStrictAcceptorCheck {{ 'yes' if ssh_config_gssapistrictacceptorcheck else 'no' }}
{% endif %}

# Host Based Authentication
# =========================

HostbasedAuthentication {{ 'yes' if ssh_config_hostbasedauthentication else 'no' }}
{% if ssh_config_hostbasedauthentication %}
HostbasedUsesNameFromPacketOnly {{ 'yes' if ssh_config_hostbasedusesnamefrompacketonly else 'no' }}
IgnoreRhosts {{ 'yes' if ssh_config_ignorerhosts else 'no' }}
IgnoreUserKnownHosts {{ 'yes' if ssh_config_ignoreuserknownhosts else 'no' }}
{% if ssh_config_hostkeyagent != 'none' %}
HostKeyAgent {{ ssh_config_hostkeyagent }}
{% endif %}
{% if ssh_config_hostcertificate != 'none' %}
HostCertificate {{ ssh_config_hostcertificate }}
{% endif %}
{% endif %}

# Print
# =====

PrintLastLog {{ 'yes' if ssh_config_printlastlog else 'no' }}
PrintMotd {{ 'yes' if ssh_config_printmotd else 'no' }}
Banner {{ ssh_config_banner }}
VersionAddendum {{ ssh_config_versionaddendum }}

# Permissions
# ===========

{% if ssh_config_denyusers != 'none' %}
DenyUsers {{ ssh_config_denyusers }}
{% endif %}
{% if ssh_config_allowusers != 'any' %}
AllowUsers {{ ssh_config_allowusers }}
{% endif %}
{% if ssh_config_denygroups != 'none' %}
DenyGroups {{ ssh_config_denygroups }}
{% endif %}
{% if ssh_config_allowgroups != 'any' %}
AllowGroups {{ ssh_config_allowgroups }}
{% endif %}
{% if (ssh_config_denyusers == 'none' and 
       ssh_config_allowusers == 'any' and
       ssh_config_denygroups == 'none' and
       ssh_config_allowgroups == 'any' ) %}
# No allow or deny statements for specific users or groups defined.
{% endif %}

# Connection Settings
# ===================

ClientAliveCountMax {{ ssh_config_clientalivecountmax | int | string }}
ClientAliveInterval {{ ssh_config_clientaliveinterval | int | string }}
LoginGraceTime {{ ssh_config_logingracetime | int | string }}
MaxAuthTries {{ ssh_config_maxauthtries }}
MaxSessions {{ ssh_config_maxsessions }}
MaxStartups {{ ssh_config_maxstartups }}
TCPKeepAlive {{ 'yes' if ssh_config_tcpkeepalive else 'no' }}
RekeyLimit {{ ssh_config_rekeylimit }}

# Settings
# ========

LogLevel {{ ssh_config_loglevel }}
SyslogFacility {{ ssh_config_syslogfacility }}
ExposeAuthInfo {{ 'yes' if ssh_config_exposeauthinfo else 'no' }}
UseDNS {{ 'yes' if ssh_config_usedns else 'no' }}
StrictModes {{ 'yes' if ssh_config_strictmodes else 'no' }}
Compression {{ 'yes' if ssh_config_compression else 'no' }}

# Environment
# ===========

{% for envvar in ssh_config_acceptenv %}
AcceptEnv {{ envvar }}
{% endfor %}
{% for envvar in ssh_config_setenv %}
SetEnv {{ envvar }}
{% endfor %}
PermitUserEnvironment {{ 'yes' if ssh_config_permituserenvironment else 'no' }}
PermitUserRC {{ 'yes' if ssh_config_permituserrc else 'no' }}
{% if ssh_config_forcecommand != 'none' %}
ForceCommand {{ ssh_config_forcecommand }}
{% endif %}

# Forwarding
# ==========

DisableForwarding {{ 'yes' if ssh_config_disableforwarding else 'no' }}
PermitTTY {{ 'yes' if ssh_config_permittty else 'no' }}
AllowAgentForwarding {{ 'yes' if ssh_config_allowagentforwarding else 'no' }}
AllowTcpForwarding {{ 'yes' if ssh_config_allowtcpforwarding else 'no' }}
PermitTunnel {{ 'yes' if ssh_config_permittunnel else 'no' }}
{% for listen in ssh_config_permitlisten %}
PermitListen {{ listen }}
{% endfor %}
{% for open in ssh_config_permitopen %}
PermitOpen {{ open }}
{% endfor %}
GatewayPorts {{ ssh_config_gatewayports }}
AllowStreamLocalForwarding {{ 'yes' if ssh_config_allowstreamlocalforwarding else 'no' }}
StreamLocalBindMask {{ ssh_config_streamlocalbindmask }}
StreamLocalBindUnlink {{ 'yes' if ssh_config_streamlocalbindunlink else 'no' }}
X11Forwarding {{ 'yes' if ssh_config_x11forwarding else 'no' }}
X11DisplayOffset {{ ssh_config_x11displayoffset }}
X11UseLocalhost {{ 'yes' if ssh_config_x11uselocalhost else 'no' }}
XAuthLocation {{ ssh_config_xauthlocation }}

# System
# ======

ChrootDirectory {{ ssh_config_chrootdirectory }}
PidFile {{ ssh_config_pidfile }}
IPQoS {{ ssh_config_ipqos }}
{% for subsystem in ssh_config_subsystem %}
Subsystem {{ subsystem }}
{% endfor %}
{% if ssh_config_useblacklist %} {# If blacklistd daemon is not installed this line can not be present #}
UseBlacklist {{ 'yes' if ssh_config_useblacklist else 'no' }}
{% endif %}

# Encryption
# ==========

{% for hostkey in ssh_config_managed_hostkeys | map(attribute='type') | list | union(ssh_config_allowed_hostkeys) | unique | sort %}
HostKey /etc/ssh/ssh_host_{{ hostkey }}_key
{% endfor %}
{% if ssh_config_ciphers != 'default' %}
Ciphers {{ ssh_config_ciphers }}
{% endif %}
{% if ssh_config_macs != 'default' %}
MACs {{ ssh_config_macs }}
{% endif %}
{% if ssh_config_kexalgorithms != 'default' %}
KexAlgorithms {{ ssh_config_kexalgorithms }}
{% endif %}
{% if ssh_config_hostkeyalgorithms != 'default' %}
HostKeyAlgorithms {{ ssh_config_hostkeyalgorithms }}
{% endif %}
{% if ssh_config_pubkeyacceptedkeytypes != 'default' %}
PubkeyAcceptedKeyTypes {{ ssh_config_pubkeyacceptedkeytypes }}
{% endif %}
{% if ssh_config_hostbasedacceptedkeytypes != 'default' %}
HostbasedAcceptedKeyTypes {{ ssh_config_hostbasedacceptedkeytypes }}
{% endif %}
{% if ssh_config_fingerprinthash != 'default' %}
FingerprintHash {{ ssh_config_fingerprinthash }}
{% endif %}
